	;	31,05,06
	list p=16f84a
	include<p16f84a.inc>
		;18 02 06  / METRON
RG1	equ	0x10
RG2	equ	0x11
LA1c	equ	0x05
LA1m	equ	0xA8
MI1c	equ	0x06
MI1m	equ	0xE3
RE1c	equ	0x07    
RE1m	equ	0x7D
CI1c	equ	0x08
CI1m	equ	0x88
COLc	equ	0x0A
COLm	equ 	0x3B
REc	equ	0x0C
REm	equ	0xFD
LAc	equ	0x10
LAm	equ	0xAD
TON	equ	0x10	;const   400   
AKCENT	equ	0x40	;const  .  100
TEMP	equ	0x12	;    TEMPA Fp
TMP	equ	0x13	;    TEMPA Fp
CTMP	equ	0x14	;    TEMP  6 
;REG1	equ	0x15
;REG2	equ	0x16
TIME1	equ	0x17
TIME2	equ	0x18
TIME3	equ	0x19	;.     
TIME4	equ	0x1A	;.    
const8	equ	0x1B	;.    
W_copy	equ	0x1C
STATUS_copy	equ	0x1D
FSR_copy	equ	0x1E
cikl	equ	0x1F

;		
	ORG	0
	goto	SRT
	ORG	4
INTSERV	movwf	W_copy
	movf	STATUS,W
	movwf	STATUS_copy
	movf	FSR,W
	movwf	FSR_copy
;
	movf	TIME1,1		;
	btfss	STATUS,Z
	goto	SRDB		; f \
	movf	TIME4,0
	sublw	0xFF
	btfss	STATUS,Z
	goto	SRDM		; f \
	movf	TIME3,0
	sublw	0xFF
	btfss	STATUS,Z
	goto	NMM		; f  
	goto	RWNO		;  
SRDB	movf	TIME1,0
	sublw	0x01
	btfsc	STATUS,C
	goto	NMB		; f  
	movf	TIME1,0
	sublw	0x04
	btfsc 	STATUS,C
	goto	SREDBL		; f \
	goto	MNOGO		;f  
SRDM	movf	TIME4,0
	sublw	0x04
	btfss	STATUS,C
	goto	MALO		;f  
	goto	SREDML		; f \
MALO	movlw	B'00111111'
	goto	I1
SREDML	movlw	B'01011111'
	goto	I1
NMM	movlw	B'01101111'
	goto	I1
NMB	movlw	B'01111011'
	goto	I1
SREDBL	movlw	b'01111101'
	goto	I1
MNOGO	movlw	B'01111110'
	goto	I1
RWNO	movlw	B'01110111'
I1	movwf	RG2
;		WIWOD	call	WRG1
	call	WRG2
	movlw	0x01
	movwf	TIME1
	movwf	TIME2
	movlw	0xFE
	movwf	TIME3
	movwf	TIME4
I9	bcf	INTCON,INTF	;   INT
;
	movf	FSR_copy,W
	movwf	FSR
	movf	STATUS_copy,W
	movwf	STATUS
	swapf	W_copy,F
	swapf	W_copy,W
	retfie
;
WRG1	;return
	movlw	0x08		;  \  
	movwf	const8
I4	rrf	RG1
	btfsc	STATUS,C
	goto	I2
	bcf	PORTA,0
	goto	I3
I2	bsf	PORTA,0
I3	bsf	PORTA,1
	nop
	nop
	bcf	PORTA,1
	decfsz	const8
	goto	I4
	rrf	RG1
	goto	I8
;
WRG2	;return
	movlw	0x08		;    RG2 
	movwf	const8
I5	rrf	RG2
	btfsc	STATUS,C
	goto	I6
	bcf	PORTA,0
	goto	I7
I6	bsf	PORTA,0
I7	bsf	PORTA,2
	nop
	nop
	bcf	PORTA,2
	decfsz	const8
	goto	I5
	rrf	RG2
I8	bsf	PORTA,3
	nop
	nop
	bcf	PORTA,3
	return
	
;--------------------------------------------------------------

SRT	clrf	PORTA
	bsf	STATUS,RP0
	movlw	B'00000000'	;   
	movwf	TRISA
	bcf 	STATUS,RP0
	clrf	PORTB
	bsf	STATUS,RP0
	movlw	B'11111111'	;    
	movwf	TRISB
	movlw	B'11000111'	;   TMR0 128
	movwf	OPTION_REG	;    
	bcf	OPTION_REG,NOT_RBPU
	bcf	STATUS,RP0
	movlw	0x06
	movwf  	CTMP
	movlw	0x96
	movwf	TEMP
	goto	START
;			   
ZADERV	;return
DLY1	nop
	decfsz	TIME1
	goto	DLY2
	return
DLY2	decfsz	TIME2
	goto	DLY2
	goto	DLY1
;		  1.25 ms
ZADR5	movlw	0x06
	movwf	TIME1
	movlw	0x09
	movwf	TIME2
LDY1	decfsz	TIME1
	goto	LDY2
	return
LDY2	decfsz	TIME2
	goto	LDY2
	goto	LDY1
;		  5 ms
ZADR2	movlw	0x12
	movwf	TIME1
	movlw	0x28
	movwf	TIME2
D1	decfsz	TIME1
	goto	D2
	return
D2	decfsz	TIME2
	goto	D2
	goto	D1
;		  20 ms
ZADR20	;return
	movlw	0x52
	movwf	TIME1
	movlw	0xC0
	movwf	TIME2
DY1	decfsz	TIME1
	goto	DY2
	return
DY2	decfsz	TIME2
	goto	DY2
	goto	DY1
;		  
TEMPO	call	ZADR20
T1	btfss	PORTB,5		;KN TEMP  ?
	goto	T1		;
	call	ZADR20
	movf	CTMP,W
	andlw	0x06		;1 
	btfss	STATUS,Z
	goto	T2
	movlw	0x55		;140   
	movwf	TEMP
	goto	ENDTEMP
T2	movf	CTMP,W
	andlw	0x05		;2 
	btfss	STATUS,Z
	goto	T3
	movlw	0xFF		;40   
	movwf	TEMP
	goto	ENDTEMP
T3	movf	CTMP,W
	andlw	0x04		;3 
	btfss	STATUS,Z
	goto	T4
	movlw	0xC8		;60
	movwf	TEMP
	goto	ENDTEMP
T4	movf	CTMP,W
	andlw	0x03		;4 
	btfss	STATUS,Z
	goto	T5
	movlw	0x96		;80   
	movwf	TEMP
	goto	ENDTEMP
T5	movf	CTMP,W
	andlw	0x02		;5 
	btfss	STATUS,Z
	goto	T6
	movlw	0x78		;100   
	movwf	TEMP
	goto	ENDTEMP
T6	nop			;6 
	movlw	0x64		;120   
	movwf	TEMP
ENDTEMP	decfsz	CTMP
	return
	movlw	0x06
	movwf	CTMP
	return
;-------------------------------------------------------------------------
;		 
START	call	ZADR20
S2	btfss	PORTB,0x06	;KN   ?
	goto	S2		;
	call	ZADR20		;
	movlw	0x11		;   8*2 	
	movwf	TIME3
	movlw	B'01111111'
	movwf	RG1
	movwf	RG2
	bsf	STATUS,C
S3 	call	WRG1
	call	WRG2
	movlw	0x03		;  0.06 
	movwf	TIME4
	call	ZADR20
	decfsz	TIME4
	goto	$-2
	rrf	RG1
	rrf	RG2
	decfsz	TIME3
	goto	S3
	movlw	0xFF
	movwf	RG1
	call	WRG1
	movlw	B'00001000'	;
	movwf	INTCON		;    PORTB
	sleep
	btfss	PORTB,0x06	;KAMERTON
	goto	KMRT
	btfss	PORTB,0x07	;METRONOM
	goto 	MTRN
	goto	START 
;--------------------------------------------------------------------------
;		METRONOM
MTRN	bcf	RG1,7		; "METRONOM"
	call	WRG1
	call	ZADR20
M1	btfss	PORTB,0x07	; >   ? 
	goto	M1		;
DOL1.4	call	ZADR20
M2	btfss	PORTB,0x06	;KN  <  ?
	goto	M2		;
	call	ZADR20		;
	movlw	B'00111111'		;clear 2/4
	movwf	RG1		;  1/4
M1.4	bcf	RG1,01		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M3	bsf	PORTA,4		; 
	call	ZADR5
	bcf	PORTA,4		;400 
	call	ZADR5
	decfsz	TMP
	goto	M3
	bsf	RG1,01		;   
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M4	call	ZADR5		;
	call	ZADR5
	decfsz	TMP
	goto	M4
	btfss	PORTB,5		; TEMP
	call	TEMPO		;
	btfss	PORTB,6		;  < 
	goto	START		;a
	btfss	PORTB,7		;  > 
	goto	DOL2.4		;
	goto	M1.4
DOL2.4	call	ZADR20
M5	btfss	PORTB,7
	goto	M5
	call	ZADR20
M6	btfss	PORTB,6		; <  ?
	goto	M6		;
	call	ZADR20
	movlw	B'01011111'		;clear 3/4 clear 1/4
	movwf	RG1		; . 2/4
M2.4	bcf	RG1,1		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M7	bsf	PORTA,4		;TON 100 
	call	ZADR5
	bcf	PORTA,4		;400 
	call	ZADR5
	decfsz	TMP
	goto	M7
	bsf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W		;pause
	movwf	TMP
M8	call	ZADR5
	call	ZADR5
	decfsz	TMP
	goto	M8
	bcf	RG1,0		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
	bcf	STATUS,C
	rrf	TMP,1
	bcf	STATUS,C
	rrf	TMP,1
M9	bsf	PORTA,4		;AKCENT 100 
	call	ZADR2
	bcf	PORTA,4		;100 
	call	ZADR2
	decfsz	TMP
	goto	M9
	bsf	RG1,0		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M10	call	ZADR5		;pause
	call	ZADR5
	decfsz	TMP
	goto	M10
	btfss	PORTB,5		;KN TEMP
	call	TEMPO		;
	btfss	PORTB,6		;<
	goto	DOL1.4
	btfss	PORTB,7		;>
	goto	DOL3.4
	goto	M2.4
DOL3.4	call	ZADR20
M11	btfss	PORTB,7		;>
	goto	M11
	call	ZADR20
M12	btfss	PORTB,6		;<
	goto	M12
	call	ZADR20
	movlw	B'01101111'	;clear4/4 clear2/4
	movwf	RG1		; . 3/4
M3.4	bcf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M13	bsf	PORTA,4		;TON 400 
	call	ZADR5
	bcf	PORTA,4		;400 
	call	ZADR5
	decfsz	TMP
	goto	M13
	bsf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W		;pause
	movwf	TMP
M14	call	ZADR5
	call	ZADR5
	decfsz	TMP
	goto	M14
	bcf	RG1,0		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
	bcf	STATUS,C
	rrf	TMP,1
	bcf	STATUS,C
	rrf	TMP,1
M15	bsf	PORTA,4		;AKCENT 100 
	call	ZADR2
	bcf	PORTA,4		;100 
	call	ZADR2
	decfsz	TMP
	goto	M15
	bsf	RG1,0		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M16	call	ZADR5		;pause
	call	ZADR5
	decfsz	TMP
	goto	M16
	bcf	RG1,0		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
	bcf	STATUS,C
	rrf	TMP,1
	bcf	STATUS,C
	rrf	TMP,1
M17	bsf	PORTA,4		;AKCENT 100 
	call	ZADR2
	bcf	PORTA,4		;100 
	call	ZADR2
	decfsz	TMP
	goto	M17
	bsf	RG1,0		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M18	call	ZADR5		;pause
	call	ZADR5
	decfsz	TMP
	goto	M18
	btfss	PORTB,5		; TEMP
	call	TEMPO		;
	btfss	PORTB,6		;  < 
	goto	DOL2.4		;a
	btfss	PORTB,7		;  > 
	goto	DOL4.4		;
	goto	M3.4
DOL4.4	call	ZADR20
M19	btfss	PORTB,7
	goto	M19
	call	ZADR20
M20	btfss	PORTB,6
	goto	M20
	call	ZADR20
	movlw	B'01110111'		;clear5/4 clear3/4
	movwf	RG1		;  4/4
M4.4	bcf	RG1,1		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M21	bsf	PORTA,4		;TON 400 
	call	ZADR5
	bcf	PORTA,4		;400 
	call	ZADR5
	decfsz	TMP
	goto	M21
	bsf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W		;pause
	movwf	TMP
M22	call	ZADR5
	call	ZADR5
	decfsz	TMP
	goto	M22
	movlw	0x03
	movwf	cikl
M36	bcf	RG1,0		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
	bcf	STATUS,C
	rrf	TMP,1
	bcf	STATUS,C
	rrf	TMP,1
M23	bsf	PORTA,4		;AKCENT 100 
	call	ZADR2
	bcf	PORTA,4		;100 
	call	ZADR2
	decfsz	TMP
	goto	M23
	bsf	RG1,0		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M24	call	ZADR5		;pause
	call	ZADR5
	decfsz	TMP
	goto	M24
	decfsz	cikl
	goto	M36
	btfss	PORTB,5		; TEMP
	call	TEMPO		;
	btfss	PORTB,6		;  < 
	goto	DOL3.4		;a
	btfss	PORTB,7		;  > 
	goto	DOL5.4		;
	goto	M4.4
DOL5.4	call	ZADR20
M29	btfss	PORTB,7
	goto	M29
	call	ZADR20
M30	btfss	PORTB,6
	goto	M30
	call	ZADR20
	movlw	B'01111011'
	movwf	RG1		; 5/4 clear4/4
M5.4	bcf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M31	bsf	PORTA,4		;TON 400 
	call	ZADR5
	bcf	PORTA,4		;400 
	call	ZADR5
	decfsz	TMP
	goto	M31
	bsf	RG1,1		; .  
	call	WRG1
	movf	TEMP,W		;pause
	movwf	TMP
M32	call	ZADR5
	call	ZADR5
	decfsz	TMP
	goto	M32
	movlw	0x04
	movwf	cikl
M35	bcf	RG1,0		;  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
	bcf	STATUS,C
	rrf	TMP,1
	bcf	STATUS,C
	rrf	TMP,1
M33	bsf	PORTA,4		;AKCENT 100 
	call	ZADR2
	bcf	PORTA,4		;100 
	call	ZADR2
	decfsz	TMP
	goto	M33
	bsf	RG1,0		; .  
	call	WRG1
	movf	TEMP,W
	movwf	TMP
M34	call	ZADR5		;pause
	call	ZADR5
	decfsz	TMP
	goto	M34
	decfsz	cikl
	goto	M35
	btfss	PORTB,5
	call	TEMPO
	btfss	PORTB,6
	goto	DOL4.4
	btfss	PORTB,7
	goto	DOL5.4
	goto	M5.4
;-----------------------------------------------------------------------------
;			KAMERTON
;			    
KMRT	bcf	RG2,7		; 
	call	WRG2
NOTALA1	call	ZADR20
K1	btfss	PORTB,7		; >   ?
	goto	K1
	call	ZADR20		;
K2	btfss	PORTB,6		; <   ?
	goto	K2
	call	ZADR20		;
	movlw	B'10111111'		;clear MI1
	movwf	RG1		;  1
	call	WRG1
	clrf	INTCON
LA1	bsf	PORTA,4		; T/2
	movlw	LA1c
	movwf	TIME1
	movlw	LA1m
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	LA1c
	movwf	TIME1
	movlw	LA1m
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	LA1		;
	btfss	PORTB,6		;<
	goto	START
	btfss	PORTB,7		;>
	goto	NOTAMI1
	btfss	PORTB,5		;
	call	MSHaLA1
	goto	NOTALA1
NOTAMI1	call	ZADR20
K3	btfss	PORTB,7		; >   ?
	goto	K3
	call	ZADR20		;
K4	btfss	PORTB,6		; <   ?
	goto	K4
	call	ZADR20		;
	movlw	B'11011111'		;clear RE1 LA1
	movwf 	RG1		;  MI1
	call	WRG1
	clrf	INTCON
MI1	bsf	PORTA,4		; T/2
	movlw	MI1c
	movwf	TIME1
	movlw	MI1m
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	MI1c
	movwf	TIME1
	movlw	MI1m
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	MI1		;
	btfss	PORTB,6		;<
	goto	NOTALA1
	btfss	PORTB,7		;>
	goto	NOTARE1
	btfss	PORTB,5		;   1
	call	MSHaMI1
	goto	NOTAMI1
NOTARE1	call	ZADR20
K5	btfss	PORTB,7		; >   ?
	goto	K5
	call	ZADR20		;
K6	btfss	PORTB,6		; <   ?
	goto	K6
	call	ZADR20		;
	movlw	B'11101111'	;clear CI1 MI1
	movwf 	RG1		;  RE1
	call	WRG1
	clrf	INTCON
RE1	bsf	PORTA,4		; T/2
	movlw	RE1c
	movwf	TIME1
	movlw	RE1m
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	RE1c
	movwf	TIME1
	movlw	RE1m
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	RE1		;
	btfss	PORTB,6		;<
	goto	NOTAMI1
	btfss	PORTB,7		;>
	goto	NOTACI1
	btfss	PORTB,5		;   1
	call	MSHaRE1
	goto	NOTARE1
NOTACI1	call	ZADR20
K7	btfss	PORTB,7		; >   ?
	goto	K7
	call	ZADR20		;
K8	btfss	PORTB,6		; <   ?
	goto	K8
	call	ZADR20		;
	movlw	B'11110111'	;clear COL RE1
	movwf 	RG1		;  CI1
	call	WRG1
	clrf	INTCON
CI1	bsf	PORTA,4		; T/2
	movlw	CI1c
	movwf	TIME1
	movlw	CI1m
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	CI1c
	movwf	TIME1
	movlw	CI1m
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	CI1		;
	btfss	PORTB,6		;<
	goto	NOTARE1
	btfss	PORTB,7		;>
	goto	NOTACOL
	btfss	PORTB,5		;
	call	MSHaCI1
	goto	NOTACI1
NOTACOL	call	ZADR20
K9	btfss	PORTB,7		; >   ?
	goto	K9
	call	ZADR20		;
K10	btfss	PORTB,6		; <   ?
	goto	K10
	call	ZADR20		;
	movlw	B'11111011'	;clear RE CI1
	movwf	RG1		;  COL
	call	WRG1
	clrf	INTCON
COL	bsf	PORTA,4		; T/2
	movlw	COLc
	movwf	TIME1
	movlw	COLm
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	COLc
	movwf	TIME1
	movlw	COLm
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	COL		;
	btfss	PORTB,6		;<
	goto	NOTACI1
	btfss	PORTB,7		;>
	goto	NOTARE
	btfss	PORTB,5		;
	call	MSHaCOL
	goto	NOTACOL
NOTARE	call	ZADR20
K11	btfss	PORTB,7		; >   ?
	goto	K11
	call	ZADR20		;
K12	btfss	PORTB,6		; <   ?
	goto	K12
	call	ZADR20		;
	movlw	B'11111101'	;clear LA COL
	movwf	RG1		;  RE
	call	WRG1
	clrf	INTCON
RE	bsf	PORTA,4		; T/2
	movlw	REc
	movwf	TIME1
	movlw	REm
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	REc
	movwf	TIME1
	movlw	REm
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	RE		;
	btfss	PORTB,6		;<
	goto	NOTACOL
	btfss	PORTB,7		;>
	goto	NOTALA
	btfss	PORTB,5		;
	call	MSHaRE
	goto	NOTARE
NOTALA	call	ZADR20
K13	btfss	PORTB,7		; >   ?
	goto	K13
	call	ZADR20		;
K14	btfss	PORTB,6		; <   ?
	goto	K14
	call	ZADR20		;
	movlw	B'11111110'	;clear RE
	movwf 	RG1		;  LA
	call	WRG1
	clrf	INTCON
LA	bsf	PORTA,4		; T/2
	movlw	LAc
	movwf	TIME1
	movlw	LAm
	movwf	TIME2
	call	ZADERV
	bcf	PORTA,4		;T/2
	movlw	LAc
	movwf	TIME1
	movlw	LAm
	movwf	TIME2
	call	ZADERV
	btfss	INTCON,RBIF	;  ?
	goto	LA		;
	btfss	PORTB,6		;<
	goto	NOTARE
	btfss	PORTB,7		;>
	goto	NOTALA
	btfss	PORTB,5		;
	call	MSHaLA
	goto	NOTALA

;---------------------------------------------------------------------------------------------
;		meachure
MSHaLA1	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z1	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zLA1	nop
	movlw	LA1c
	movwf	TIME1
	movlw	LA1m
	movwf	TIME2
	call	ZADERV
	nop
	movlw	LA1c
	movwf	TIME1
	movlw	LA1m
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z1		;
	goto	KMSH
;
MSHaMI1	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z2	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zMI1	nop			; T/2
	movlw	MI1c
	movwf	TIME1
	movlw	MI1m
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	MI1c
	movwf	TIME1
	movlw	MI1m
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z2		;
	goto	KMSH
;
MSHaRE1	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z3	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zRE1	nop			; T/2
	movlw	RE1c
	movwf	TIME1
	movlw	RE1m
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	RE1c
	movwf	TIME1
	movlw	RE1m
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z3		;
	goto	KMSH
;
MSHaCI1	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z4	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zCI1	nop 			; T/2
	movlw	CI1c
	movwf	TIME1
	movlw	CI1m
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	CI1c
	movwf	TIME1
	movlw	CI1m
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z4		;
	goto	KMSH
;
MSHaCOL	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z5	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zCOL	nop			; T/2
	movlw	COLc
	movwf	TIME1
	movlw	COLm
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	COLc
	movwf	TIME1
	movlw	COLm
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z5		;
	goto	KMSH
;
MSHaRE	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z6	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zRE	nop			; T/2
	movlw	REc
	movwf	TIME1
	movlw	REm
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	REc
	movwf	TIME1
	movlw	REm
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z6		;
	goto	KMSH
;	
MSHaLA	call	ZADR20
	btfss	PORTB,5		; >   ?
	goto	$-1
z7	clrf	INTCON		;   
	bsf	INTCON,INTE	;    INT
	btfss	INTCON,INTF	;   	
	goto	$-1
	bcf	INTCON,INTF	;   INT
	bsf	INTCON,GIE	;  
zLA	nop			; T/2
	movlw	LAc
	movwf	TIME1
	movlw	LAm
	movwf	TIME2
	call	ZADERV
	nop			;T/2
	movlw	LAc
	movwf	TIME1
	movlw	LAm
	movwf	TIME2
	call	ZADERV
	call	A1
	btfss	INTCON,RBIF	;  ?
	goto	z7		;
KMSH	movlw	B'01111111'	;  ,  
	movwf	RG2
	call	WRG2
	return
;	
A1	incf	TIME3,1		;     
	movlw	0xff
	xorwf	TIME3,0		; 
	btfss	STATUS,Z
	goto	A1
	movlw	0xff
	incf	TIME4,1		; 
	xorwf	TIME4,0
	btfss	STATUS,Z
	goto	A1
	return
	end

